ログイン後、ttyで「♦:コマンドが見つかりません」


24

Lubuntuを12.10から13.04にアップグレードすると、この問題が発生します。

Ctrl+ Alt+ を押して1、ログイン、パスワードを入力し、2秒待ってから取得します♦: command not found"。このメッセージの後、問題なくコマンドを入力できますが、それは何ですか?

echo $PATH
/usr/lib/lightdm/lightdm:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games:/usr/local/games:/home/vitaly/bin:/usr/java/jdk1.7.0_17/bin

私の.bashrcファイルは:

# ~/.bashrc: executed by bash(1) for non-login shells.
# see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
# for examples

# If not running interactively, don't do anything
case $- in
    *i*) ;;
      *) return;;
esac

# don't put duplicate lines or lines starting with space in the history.
# See bash(1) for more options
HISTCONTROL=ignoreboth

# append to the history file, don't overwrite it
shopt -s histappend

# for setting history length see HISTSIZE and HISTFILESIZE in bash(1)
HISTSIZE=1000
HISTFILESIZE=2000

# check the window size after each command and, if necessary,
# update the values of LINES and COLUMNS.
shopt -s checkwinsize

# If set, the pattern "**" used in a pathname expansion context will
# match all files and zero or more directories and subdirectories.
#shopt -s globstar

# make less more friendly for non-text input files, see lesspipe(1)
[ -x /usr/bin/lesspipe ] && eval "$(SHELL=/bin/sh lesspipe)"

# set variable identifying the chroot you work in (used in the prompt below)
if [ -z "${debian_chroot:-}" ] && [ -r /etc/debian_chroot ]; then
    debian_chroot=$(cat /etc/debian_chroot)
fi

# set a fancy prompt (non-color, unless we know we "want" color)
case "$TERM" in
    xterm-color) color_prompt=yes;;
esac

# uncomment for a colored prompt, if the terminal has the capability; turned
# off by default to not distract the user: the focus in a terminal window
# should be on the output of commands, not on the prompt
#force_color_prompt=yes

if [ -n "$force_color_prompt" ]; then
    if [ -x /usr/bin/tput ] && tput setaf 1 >&/dev/null; then
    # We have color support; assume it's compliant with Ecma-48
    # (ISO/IEC-6429). (Lack of such support is extremely rare, and such
    # a case would tend to support setf rather than setaf.)
    color_prompt=yes
    else
    color_prompt=
    fi
fi

if [ "$color_prompt" = yes ]; then
    PS1='${debian_chroot:+($debian_chroot)}\[\033[01;32m\]\u@\h\[\033[00m\]:\[\033[01;34m\]\w\[\033[00m\]\$ '
else
    PS1='${debian_chroot:+($debian_chroot)}\u@\h:\w\$ '
fi
unset color_prompt force_color_prompt

# If this is an xterm set the title to user@host:dir
case "$TERM" in
xterm*|rxvt*)
    PS1="\[\e]0;${debian_chroot:+($debian_chroot)}\u@\h: \w\a\]$PS1"
    ;;
*)
    ;;
esac

# enable color support of ls and also add handy aliases
if [ -x /usr/bin/dircolors ]; then
    test -r ~/.dircolors && eval "$(dircolors -b ~/.dircolors)" || eval "$(dircolors -b)"
    alias ls='ls --color=auto'
    #alias dir='dir --color=auto'
    #alias vdir='vdir --color=auto'

    alias grep='grep --color=auto'
    alias fgrep='fgrep --color=auto'
    alias egrep='egrep --color=auto'
fi

# some more ls aliases
alias ll='ls -alF'
alias la='ls -A'
alias l='ls -CF'

# Add an "alert" alias for long running commands.  Use like so:
#   sleep 10; alert
alias alert='notify-send --urgency=low -i "$([ $? = 0 ] && echo terminal || echo error)" "$(history|tail -n1|sed -e '\''s/^\s*[0-9]\+\s*//;s/[;&|]\s*alert$//'\'')"'

# Alias definitions.
# You may want to put all your additions into a separate file like
# ~/.bash_aliases, instead of adding them here directly.
# See /usr/share/doc/bash-doc/examples in the bash-doc package.

if [ -f ~/.bash_aliases ]; then
    . ~/.bash_aliases
fi

# enable programmable completion features (you don't need to enable
# this, if it's already enabled in /etc/bash.bashrc and /etc/profile
# sources /etc/bash.bashrc).
if ! shopt -oq posix; then
  if [ -f /usr/share/bash-completion/bash_completion ]; then
    . /usr/share/bash-completion/bash_completion
  elif [ -f /etc/bash_completion ]; then
    . /etc/bash_completion
  fi
fi

私の.profileファイルは:

# ~/.profile: executed by the command interpreter for login shells.
# This file is not read by bash(1), if ~/.bash_profile or ~/.bash_login
# exists.
# see /usr/share/doc/bash/examples/startup-files for examples.
# the files are located in the bash-doc package.

# the default umask is set in /etc/profile; for setting the umask
# for ssh logins, install and configure the libpam-umask package.
#umask 022

# if running bash
if [ -n "$BASH_VERSION" ]; then
    # include .bashrc if it exists
    if [ -f "$HOME/.bashrc" ]; then
    . "$HOME/.bashrc"
    fi
fi

# set PATH so it includes user's private bin if it exists
if [ -d "$HOME/bin" ] ; then
    PATH="$HOME/bin:$PATH"
fi

ファイル/etc/profileはこちら:http : //paste.ubuntu.com/5781361/


1
の出力はecho $PATH何ですか?(質問に編集してから返信してください)。
セス

1
〜/ .bashrcおよび〜/ .profileファイルをpaste.ubuntu.comにアップロードしてリンクを投稿できますか?
エリック

将来の参照のために、形状は「ダイヤモンド」と呼ばれます。
ユーザー98085

echo $PATH私の質問に追加されました。
ヴィタリーズダネビッチ

'.bashrc'のパス変数を単一引用符で囲むと、この問題が発生する可能性があります。
phyatt

回答:


28

回避策

最初に、tty1- Ctrl+ Alt+に行くときについて言及すると思いますF1

♦(ダイアモンドスーツキャラクターまたはaskubuntuモデレーター用の特別なバッジ)のような奇妙なキャラクター、~/.bashrcまたは~/.profileさまざまな初期化コマンドを含むファイルまたはその他のファイルがあるため、おそらくあなたが言ったことは起こっていると思います。

次の画像でわかるよう~/.bashrcに、単一行の♦文字内に入れてファイルを編集しました。その結果、端末を開くと、説明されている問題が発生します。

ターミナル

私がtty1にCtrl+ Alt+で行ったときも同じことが起こりF1ます。

シェルが起動されたときに初期化コマンドを含むファイル:/etc/profile/etc/bashrc~/.bash_login~/.profile~/.bashrc~/.bash_aliasesそしておそらく他の人。シェル初期化ファイルを参照してください。

これらのファイルの1つに何か問題があるかどうかをすばやく確認するには、sourceコマンドを使用できます。例えば:

source ~/.bashrc

ソースプロファイル

最終的解決

http://paste.ubuntu.com/5781361//etc/profileから調べたところ、31行目に「右から左へのオーバーライド」 -Unicode文字があることがわかりました。でファイルを開くだけで、この奇妙な文字を削除してください。そうすれば問題は消えます。‮/etc/profilesudo -H gedit /etc/profile

プロファイルファイル

娯楽として、たとえばHTML ‮で、行の前に10進コード()を使用してこのUnicode文字を挿入する場合、何が起こっているか見てください:

textこのテキストはアラビア語で書かれています!

別のより一般化されたソリューション

トラップ」を使用して、エラーの原因となった正確なコマンドを見つけます。

最初に、~/binディレクトリ内に新しいスクリプトファイルを作成する必要があります。それをlib.trap.shgedit ~/bin/lib.trap.sh)と呼びましょう。

lib_name='trap'

lib_version=20130620
#changed from lib_version=20121026 found it at /programming//a/13099228/2353900 to work well at initialization of the shell

stderr_log="/dev/shm/stderr.log"

#
# TO BE SOURCED ONLY ONCE:
#
###~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~##

if test "${g_libs[$lib_name]+_}"; then
    return 0
else
    if test ${#g_libs[@]} == 0; then
        declare -A g_libs
    fi
    g_libs[$lib_name]=$lib_version
fi


#
# MAIN CODE:
#
###~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~##

set -o pipefail  # trace ERR through pipes
set -o errtrace  # trace ERR through 'time command' and other functions
set -o nounset   ## set -u : exit the script if you try to use an uninitialised variable
set -o errexit   ## set -e : exit the script if any statement returns a non-true return value

exec 2>"$stderr_log"


###~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~##
#
# FUNCTION: EXIT_HANDLER
#
###~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~##

function exit_handler ()
{
    local error_code="$?"

    test $error_code == 0 && return;

    #
    # LOCAL VARIABLES:
    # ------------------------------------------------------------------
    #    
    local i=0
    local regex=''
    local mem=''

    local error_file=''
    local error_lineno=''
    local error_message='unknown'

    local lineno=''


    #
    # PRINT THE HEADER:
    # ------------------------------------------------------------------
    #
    # Color the output if it's an interactive terminal
    test -t 1 && tput bold; tput setf 4                                 ## red bold
    echo -e "\n(!) EXIT HANDLER\n"


    #
    # GETTING LAST ERROR OCCURRED:
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #

    #
    # Read last file from the error log
    # ------------------------------------------------------------------
    #
    if test -f "$stderr_log"
        then
            stderr=$( tail -n 1 "$stderr_log" )
            rm "$stderr_log"
    fi

    #
    # Managing the line to extract information:
    # ------------------------------------------------------------------
    #

    if test -n "$stderr"
        then        
            # Exploding stderr on :
            mem="$IFS"
            local shrunk_stderr=$( echo "$stderr" | sed 's/\: /\:/g' )
            IFS=':'
            local stderr_parts=( $shrunk_stderr )
            IFS="$mem"

            # Storing information on the error
            error_file="${stderr_parts[0]}"
            error_lineno="${stderr_parts[1]}"
            error_message=""

            for (( i = 3; i <= ${#stderr_parts[@]}; i++ ))
                do
                    error_message="$error_message "${stderr_parts[$i-1]}": "
            done

            # Removing last ':' (colon character)
            error_message="${error_message%:*}"

            # Trim
            error_message="$( echo "$error_message" | sed -e 's/^[ \t]*//' | sed -e 's/[ \t]*$//' )"
    fi

    #
    # GETTING BACKTRACE:
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #
    _backtrace=$( backtrace 2 )


    #
    # MANAGING THE OUTPUT:
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #

    local lineno=""
    regex='^([a-z]{1,}) ([0-9]{1,})$'

    if [[ $error_lineno =~ $regex ]]

        # The error line was found on the log
        # (e.g. type 'ff' without quotes wherever)
        # --------------------------------------------------------------
        then
            local row="${BASH_REMATCH[1]}"
            lineno="${BASH_REMATCH[2]}"

            echo -e "FILE:\t\t${error_file}"
            echo -e "${row^^}:\t\t${lineno}\n"

            echo -e "ERROR CODE:\t${error_code}"             
            test -t 1 && tput setf 6                                    ## white yellow
            echo -e "ERROR MESSAGE:\n$error_message"


        else
            regex="^${error_file}\$|^${error_file}\s+|\s+${error_file}\s+|\s+${error_file}\$"
            if [[ "$_backtrace" =~ $regex ]]

                # The file was found on the log but not the error line
                # (could not reproduce this case so far)
                # ------------------------------------------------------
                then
                    echo -e "FILE:\t\t$error_file"
                    echo -e "ROW:\t\tunknown\n"

                    echo -e "ERROR CODE:\t${error_code}"
                    test -t 1 && tput setf 6                            ## white yellow
                    echo -e "ERROR MESSAGE:\n${stderr}"

                # Neither the error line nor the error file was found on the log
                # (e.g. type 'cp ffd fdf' without quotes wherever)
                # ------------------------------------------------------
                else
                    #
                    # The error file is the first on backtrace list:

                    # Exploding backtrace on newlines
                    mem=$IFS
                    IFS='
                    '
                    #
                    # Substring: I keep only the carriage return
                    # (others needed only for tabbing purpose)
                    IFS=${IFS:0:1}
                    local lines=( $_backtrace )

                    IFS=$mem

                    error_file=""

                    if test -n "${lines[1]}"
                        then
                            array=( ${lines[1]} )

                            for (( i=2; i<${#array[@]}; i++ ))
                                do
                                    error_file="$error_file ${array[$i]}"
                            done

                            # Trim
                            error_file="$( echo "$error_file" | sed -e 's/^[ \t]*//' | sed -e 's/[ \t]*$//' )"
                    fi

            echo -e "ROW, FILE:\t\t${lines[2]   }\n"

                    echo -e "ERROR CODE:\t${error_code}"
                    test -t 1 && tput setf 6                            ## white yellow
                    if test -n "${stderr}"
                        then
                            echo -e "ERROR MESSAGE:\n${stderr}"
                        else
                            echo -e "ERROR MESSAGE:\n${error_message}"
                    fi
            fi
    fi

    #
    # PRINTING THE BACKTRACE:
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #

    test -t 1 && tput setf 7                                            ## white bold
    echo -e "\n$_backtrace\n"

    #
    # EXITING:
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ #

    test -t 1 && tput setf 4                                            ## red bold
    echo "Exiting!"

    test -t 1 && tput sgr0 # Reset terminal

    exit "$error_code"
}
trap exit_handler ERR                                                  # ! ! ! TRAP EXIT ! ! !
#trap exit ERR                                                        # ! ! ! TRAP ERR ! ! ! 


###~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~##
#
# FUNCTION: BACKTRACE
#
###~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~##

function backtrace
{
    local _start_from_=0

    local params=( "$@" )
    if (( "${#params[@]}" >= "1" ))
        then
            _start_from_="$1"
    fi

    local i=0
    local first=false
    while caller $i > /dev/null
    do
        if test -n "$_start_from_" && (( "$i" + 1   >= "$_start_from_" ))
            then
                if test "$first" == false
                    then
                        echo "BACKTRACE IS:"
                        first=true
                fi
                caller $i
        fi
        let "i=i+1"
    done
}

return 0

今、あなたがしなければならない唯一のことは、ファイルの先頭に次の行を置くことです/etc/profilesudo -H gedit /etc/profile):

source '/home/<user_name>/bin/lib.trap.sh'

<user_name>ユーザー名で変更します。このように、シェルが呼び出されたときに初期化コマンドを含むすべてのファイルは「トラップ」を通過します。

/etc/profileたとえば、間違ったコマンドがあるかどうかをテストするには、ターミナルの次のコマンドで実行します。

bashソース/ etc / profile

この場合のように、何かが間違っている場合、結果は次のようになります。

トラップ

したがって、ファイルの行32に問題(command not found)があることを確認しました(/etc/profileファイルの先頭に新しい行を挿入したため、上記の行31ではありません)。

この一般的なソリューションを完成させるのに役立ったこの回答からのスクリプトについて、Luca Borrioneに感謝します。


追加されたコード.bashrc.profileの質問に-私はここ♦見つけることができません。
ヴィタリーズダネヴィチ

1
あなたは、初期化コマンド(含むすべてのファイルを確認する必要があり@VitalyZdanevich .bash_aliases.pam_environment必ずしも正確にこの文字、奇妙な内部をsomenthingため、など)。
ラドゥラデアヌ

2
はい、問題はから31行目にあり/etc/profileます。とても奇妙なことがあります。1つまたは2つの「Enter」を押した後、すべてを削除fiJAVA_HOME、その後はすべて問題ありません。ファイルを変更するsudo gedit /etc/profile
ラドゥラデアヌ

1
@RyanLoremIpsumいいえ、きっと。OPは私ではなくそこに貼り付けていました:)
ラドゥラデアヌ

1
すばらしいです!でこの2つの透明な線をクリアし/etc/profileます。奇妙なバッグ。
ヴィタリーズダネヴィチ

5

bashの初期化スクリプトをデバッグするには、次を実行します(仮想コンソールにログインした後)。

PS4='+ $BASH_SOURCE:$LINENO:' bash -xlic ''

上記は、仮想コンソールにログインするときのプログラムと同じように、bashをインタラクティブ(-i)ログイン(-l)モードでlogin実行します。-c ''それは、初期化スクリプトを使用して実行した後にすぐに終了なり、-xそしてPS4=...それはそれらを実行する前に、そのコマンドのファイル名と行番号とともに、その出力の各コマンドになります。これは、無効なコマンドが存在するファイルの行を特定するのに役立ちます。

ちなみに、♦は、仮想コンソールのデフォルトフォントが記号を持たない文字を印刷するために使用する記号です。


1

初期化ファイルの検索中に、♦の出力に使用される16進数を検索すると役立つ場合があります。ユニコード文字 'BLACK DIAMOND SUIT'によると、♦の16進コードは2666 です。注:少なくとも1つの他の16進コード25C6があり、同じまたは類似したシンボルを生成します。「ダイヤモンド」の検索結果を参照してください。Unicode文字検索

おそらく、そのようなもの\u2666がスクリプトの1つにあります。以下からのエコーのためのマニュアルバッシュリファレンス - 「\ uhhhhのUnicode(ISO / IEC 10646)値16進数の値がHHHHである文字(1〜4進数)」

使用される文字エンコードに依存するため、最も可能性の高いものを最初に検索することをお勧めします。echo $LC_CTYPEシェルで使用される文字エンコーディングを返す必要があります。端末の文字エンコーディングを取得する方法をご覧ください


-1 ~/.bash_historyは、PS1でインタラクティブに実行されるコマンドが格納されているためです。
ラドゥラデアヌ

ご確認、ありがとうございます。削除しました。Raduの答えにコメントとして残りを追加する必要がありますか?
iyrin

ああ、わかりません-何をする必要がありますか?Lubuntu初期化ファイルのどこに?の全文検索\u2666と♦Catfish(Lubuntu検索)を試しました-何もしませんでした。私は種をまくhistory-何もない。このメッセージは、ログイン後にのみttyでのみ表示されます。echo $LC_CTYPE空の行を取得した後。
ヴィタリーズダネビッチ

実行localeするとLC_CTYPEが表示されます。ロケール
-iyrin

この前にラドゥの答えを試してみてください!ttyで使用される文字セットを絞り込むと、ソリッドダイアモンドに対応する文字コードの出現を検索できます。RaduのRLO検索が原因である場合、この検索は無益であることが証明されます。
-iyrin

0

bashrcファイルへのフルパスとともに、bashrcファイルを編集できる既知のツールへのフルパスを記述します。

/bin/nano /home/username/.bashrc

PATH変数に対する不正使用を見つけてコメントアウトします。パスに何かを追加しようとしたときに、二重引用符ではなく一重引用符で囲まれた可能性があります。

PATH='$PATH:/path/to/new/tool' # very BAD, single quotes won't expand PATH
#    ^                       ^

PATH="$PATH:/path/to/new/tool" # Good! The double quotes allow variable expansion

.bashrcをhttps://www.shellcheck.net/のようなツールにコピーして、bashの使用に明白な問題があるかどうかを確認します。

お役に立てば幸いです。

弊社のサイトを使用することにより、あなたは弊社のクッキーポリシーおよびプライバシーポリシーを読み、理解したものとみなされます。
Licensed under cc by-sa 3.0 with attribution required.